unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, StdCtrls;

type
  TForm1 = class(TForm)
    Button1: TButton;
    Button2: TButton;
    whosturn: TLabel;
    Shape1: TShape;
    Shape2: TShape;
    Shape3: TShape;
    Shape4: TShape;
    r1c1: TLabel;
    r1c2: TLabel;
    r1c3: TLabel;
    r2c1: TLabel;
    r2c2: TLabel;
    r2c3: TLabel;
    r3c1: TLabel;
    r3c2: TLabel;
    r3c3: TLabel;
    row1: TLabel;
    row2: TLabel;
    row3: TLabel;
    tlbrd: TLabel;
    col3: TLabel;
    col2: TLabel;
    col1: TLabel;
    bltrd: TLabel;
    procedure Button2Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure r1c1Click(Sender: TObject);
    procedure r1c2Click(Sender: TObject);
    procedure r1c3Click(Sender: TObject);
    procedure r2c1Click(Sender: TObject);
    procedure r2c2Click(Sender: TObject);
    procedure r2c3Click(Sender: TObject);
    procedure r3c1Click(Sender: TObject);
    procedure r3c2Click(Sender: TObject);
    procedure r3c3Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;


var
  Form1: TForm1;
  GameBoard:array[1..3] of array[1..3] of integer;
  xturn:Boolean;


implementation

{$R *.DFM}


procedure ActivateGameBoard(isactive:boolean);
{This procedure Activates and Deactivates the Visible GameBoard
that the user sees and clicks on. To active the gameboard then
isactive needs to be true. To deactive the gameabord set isactive to false}
begin
    With Form1 Do
    Begin
        R1C1.Enabled := isactive;
        R1C2.Enabled := isactive;
        R1C3.Enabled := isactive;
        R2C1.Enabled := isactive;
        R2C2.Enabled := isactive;
        R2C3.Enabled := isactive;
        R3C1.Enabled := isactive;
        R3C2.Enabled := isactive;
        R3C3.Enabled := isactive;
    End;
end;

function ReturnXO(row,col:integer):string;
{This simply returns an X or an O or nothing based on what
is listed in the vitual game board}
begin
    Case GameBoard[row,col] of
    4: ReturnXO := 'X';
    -3: ReturnXO := 'O';
    ELSE
      ReturnXO := ' ';
    end;
end;


procedure PaintGameBoard;
{This will make the visible game board (what the user sees)
the same as the virtual game board (what the computer sees)}
begin
     With Form1 do
     begin
          R1C1.Caption := ReturnXO(1,1);
          R1C2.Caption := ReturnXO(1,2);
          R1C3.Caption := ReturnXO(1,3);
          R2C1.Caption := ReturnXO(2,1);
          R2C2.Caption := ReturnXO(2,2);
          R2C3.Caption := ReturnXO(2,3);
          R3C1.Caption := ReturnXO(3,1);
          R3C2.Caption := ReturnXO(3,2);
          R3C3.Caption := ReturnXO(3,3);
     end;

     IF Xturn then form1.whosturn.caption := 'Player X''s Turn' else form1.whosturn.caption := 'Player O''s Turn';
end;


procedure StartNewGame;
var x,y:integer;
begin
    {First remove all X's and O's from the virtual gameboard}
    for x := 1 to 3 do
    begin
       for y := 1 to 3 do GameBoard[x,y] := 0;
    end;

    {Secondly set it to be X's Turn}
    xturn := True;

    {This calls another procedure (above) that activates the
    visible gameboard allowing the users to click in the squares}

    ActivateGameBoard(TRUE);

    PaintGameBoard;

end;

procedure CheckForWin;
var value:integer;
     xwon:Boolean;
     owon:Boolean;
begin

    xwon := false;
    owon := false;

    {Check Horizontal rows}
    value := GameBoard[1,1] + GameBoard[1,2] + GameBoard[1,3];
    IF value = 12 then xwon := true;
    IF value = -9 then owon := true;
    form1.row1.caption := inttostr(value);

    value := GameBoard[2,1] + GameBoard[2,2] + GameBoard[2,3];
    IF value = 12 then xwon := true;
    IF value = -9 then owon := true;
    form1.row2.caption := inttostr(value);

    value := GameBoard[3,1] + GameBoard[3,2] + GameBoard[3,3];
    IF value = 12 then xwon := true;
    IF value = -9 then owon := true;
    form1.row3.caption := inttostr(value);

    {Check Vertical Columns}
    value := GameBoard[1,1] + GameBoard[2,1] + GameBoard[3,1];
    IF value = 12 then xwon := true;
    IF value = -9 then owon := true;
    form1.col1.caption := inttostr(value);

    value := GameBoard[1,2] + GameBoard[2,2] + GameBoard[3,2];
    IF value = 12 then xwon := true;
    IF value = -9 then owon := true;
    form1.col2.caption := inttostr(value);

    value := GameBoard[1,3] + GameBoard[2,3] + GameBoard[3,3];
    IF value = 12 then xwon := true;
    IF value = -9 then owon := true;
    form1.col3.caption := inttostr(value);
    {Check Diagonals}
    value := GameBoard[1,1] + GameBoard[2,2] + GameBoard[3,3];
    IF value = 12 then xwon := true;
    IF value = -9 then owon := true;
    form1.tlbrd.caption := inttostr(value);
    value := GameBoard[3,1] + GameBoard[2,2] + GameBoard[1,3];
    IF value = 12 then xwon := true;
    IF value = -9 then owon := true;
    form1.bltrd.caption := inttostr(value);

    IF xwon then
    begin
        form1.Whosturn.caption := 'Player X won';
        ActivateGameBoard(false);
    end;

    if owon then
    begin
         form1.Whosturn.caption := 'Player O won';
         ActivateGameBoard(false);
    end;

end;




procedure PlaceTurn(row,col:integer);
{This will place an X or an O, depending who's turn
in the row and col specified}
var value:integer;
begin

    {Computers can only see numbers so we'll make X = 4 and
    O = -3}
    IF xturn then value := 4 else value := -3;

    {If the square is not full, place the X or O on the virtual
    gameboard and make it the other players turn and finally repaint the board

    If the square is full then display a message}

    IF GameBoard[row,col] = 0 then
    begin
        GameBoard[row,col] := value;
        IF xturn then xturn := false else xturn := true;
        PaintGameBoard;
        CheckForWin;
    end
    else ShowMessage('You can''t move here');

end;





procedure TForm1.Button2Click(Sender: TObject);
begin
form1.close;

end;

procedure TForm1.Button1Click(Sender: TObject);
begin
 StartNewGame;
end;

procedure TForm1.r1c1Click(Sender: TObject);
begin
   PlaceTurn(1,1);
end;

procedure TForm1.r1c2Click(Sender: TObject);
begin
  placeturn(1,2);
end;

procedure TForm1.r1c3Click(Sender: TObject);
begin
  placeturn(1,3);
end;

procedure TForm1.r2c1Click(Sender: TObject);
begin
   placeturn(2,1);
end;

procedure TForm1.r2c2Click(Sender: TObject);
begin
  placeturn(2,2);
end;

procedure TForm1.r2c3Click(Sender: TObject);
begin
  placeturn(2,3);
  
end;

procedure TForm1.r3c1Click(Sender: TObject);
begin
  placeturn(3,1);
end;

procedure TForm1.r3c2Click(Sender: TObject);
begin
    placeturn(3,2);
end;

procedure TForm1.r3c3Click(Sender: TObject);
begin
   placeturn(3,3);
end;

end.
